/*
 * T.Reynolds Sept 2021
 * Sliding tray with rotating tray for easier access
 * for information regarding the current sense switch see End of File
 */
#include "EmonLib.h"
// Include Emon Library
EnergyMonitor emon1;
// Create an instance



bool athome=false;
bool away= false;
/*
 * no current draw IRMS*230 value=58.xx
 * 3KW kettle IRMS*230 value 4968.xx
 * a safe value to assume the device is on >2500
 * NOTE:these values will be different depening on variation of supply voltage
 * See test code below
 */

#define trayaway 2
#define trayhome 3
#define ttableaway 4
#define ttablehome 5
int triglevel=2500 ; // value sense must exceed to initiate tray
 bool traymoved=false;

void setup()  
{

  // initialize the serial port:
  Serial.begin(115200);

  emon1.current(0, 111.1);   // Current: input pin, calibration.

  pinMode(2,INPUT_PULLUP);   //  Tray microsw away
  pinMode(3,INPUT_PULLUP);  //   Tray home microsw home
  pinMode(4,INPUT_PULLUP);   // yellow wire Turntable microsw away
  pinMode(5,INPUT_PULLUP);  // red wire Turntable microsw home
  //pinMode(6,INPUT_PULLUP);  //reset button --NOT USED--
  // A0; // sensor i/p
  pinMode(7,OUTPUT); //Sense indicator LED  blue

  pinMode(12,OUTPUT); // tray will be / is moving flashing red led



}



void loop() 
{
athome=false;
away= false;

double Irms = emon1.calcIrms(1480);  // Calculate Irms only
Serial.println(Irms*230.0);           // Apparent power
double trig=Irms*230.0;

if(trig > triglevel)
  {
   digitalWrite(7,HIGH); // sense led on;
  }
   else
  {
   digitalWrite(7,LOW); // sense led off;  
  }

if(trig > triglevel  && traymoved==false) // ie device switched on
{
  traymoved=true;
  digitalWrite(12,HIGH); // moving led on;
  delay(3000);  // 3 seconds
  trayout(); // away
  tableout();
  digitalWrite(12,LOW); // moving led off;
}

if(trig < triglevel && traymoved)  // ie device switched off
{
  traymoved=false;
  delay(5000); // 5 seconds
  digitalWrite(12,HIGH); // moving led on;
  delay(10000); // 10 seconds wait before move
  tablein();
  trayin();
    digitalWrite(12,LOW); // moving led off;
}

}
  //tray pins 8 & 9
  //table pins 10 & 11
  //in1=8, in2=9 in3=10, in4 =11
void trayout()    //8,9
{
  while(digitalRead(trayaway)==1)
  {
    digitalWrite(8,1);
    digitalWrite(9,0);
  }
  digitalWrite(8,0);
}
  


void trayin()
{
    while(digitalRead(trayhome)==1)
  {
    digitalWrite(8,0);
    digitalWrite(9,1);
  }
    digitalWrite(9,0);
}
  


void tableout()   //10,11
{
  while(digitalRead(ttableaway)==1)
  {
  digitalWrite(10,1);
  digitalWrite(11,0);  
  }
    digitalWrite(10,0);
}

void tablein()
{
    while(digitalRead(ttablehome)==1)
  {
  digitalWrite(10,0);
  digitalWrite(11,1);  
  }
    digitalWrite(11,0);
}
  

/*
 * Test code to get Irms value proportional to current being drawn
 * info from:
 * https://learn.openenergymonitor.org/electricity-monitoring/ct-sensors/how-to-build-an-arduino-energy-monitor-measuring-current-only?redirected=true
 * 
 * #include "EmonLib.h"
// Include Emon Library
EnergyMonitor emon1;
// Create an instance
void setup()
{
  Serial.begin(115200);

  emon1.current(0, 111.1);             // Current: input pin, calibration.
}

void loop()
{
double Irms = emon1.calcIrms(1480);  // Calculate Irms only
Serial.print(Irms*230.0);           // Apparent power
  Serial.print(" ");
  Serial.println(Irms);             // Irms
  delay(1000);
}
 */
